########################################################################################
# EventCal.pl                                                                          #
# by XTC                                                                               #
# http://www.yabbserver.com                                                            #
########################################################################################

$Calver= "beta7.0"; #Date: 08. Dec. 2005

LoadLanguage("EventCal");

if(-e("$vardir/eventcalset.txt"))  {
require "$vardir/eventcalset.txt";
}

sub get_cal {

#<--------------------------------------------->#
# Access check to add events begin
#<--------------------------------------------->#

if ($iamguest && $ShowCalendarGuest == 1 && $INFO{'calshow'} == 1 ) { &fatal_error($maintxt{'1'}); }

$Allow_Event_Imput = 0;

if ($CalEventPerms) {
$memberinform = $memberunfo{$username};
foreach $element (split(/\,/, $CalEventPerms)) {
	chomp $element;
	if (($element eq ${$uid.$username}{'position'}) || ($element eq $memberinform)) { $Allow_Event_Imput = 1; last; }
		$memberaddgroup{$username} =~ s/\, /\,/g;
		foreach $memberaddgroups (split(/\,/, $memberaddgroup{$username})) {
			chomp $memberaddgroups;
			if ($element eq $memberaddgroups) { $Allow_Event_Imput = 1; last; }
		}
	if ($Allow_Event_Imput == 1) { last; }
}
}

unless ($Allow_Event_Imput == 1) {
if ($CalEventMods) {
foreach $elementmod (split(/\,/, $CalEventMods)) {
	chomp $elementmod;
	if ('$elementmod' == '$username') {$Allow_Event_Imput = 1; }
	if ($Allow_Event_Imput == 1) { last; }
}
}
}


	if ($iamadmin) { $Allow_Event_Imput = 1; }
	if (($iamguest) && ($CalEventPerms)) { $Allow_Event_Imput = 0; }
	if ($CalEventPerms eq "") { $Allow_Event_Imput = 1; }

#<--------------------------------------------->#
# Access check to add events end
#<--------------------------------------------->#

#<--------------------------------------------->#
# GoTo Box begin
#<--------------------------------------------->#

if ("$INFO{'calgotobox'}" == 1) {

$goyear = $FORM{'selyear'};
$gomon = $FORM{'selmon'};
$goday = $FORM{'selday'};


if ($goday) {
	$yySetLocation = qq~$scripturl?action=get_cal;calshow=1;eventdate=$goyear$gomon$goday;showmini=1~;
	&redirectexit;
}
if (!$goday) {
	$yySetLocation = qq~$scripturl?action=get_cal;calshow=1;calmon=$gomon;calyear=$goyear~;
	&redirectexit;
}
}

#<--------------------------------------------->#
# GoTo Box end
#<--------------------------------------------->#

#<--------------------------------------------->#
# Time/Days begin
#<--------------------------------------------->#

   $event_date ="$INFO{'eventdate'}";
   $sel_year=substr($event_date,0,4);
   $sel_mon=substr($event_date,4,2);
   $sel_day=substr($event_date,6,2);

   if($INFO{'calyear'}) { 
   $ausgabe1 = "$INFO{'calmon'}/01/$INFO{'calyear'} am 00:00:00";
   $heute = stringtotime ($ausgabe1);
   $daterechnug = stringtotime ($ausgabe1);
   (undef, undef, undef, undef, undef, undef, undef, undef, $newisdst) = localtime($heute);
   if ($newisdst > 0) { $userdst = ${$uid.$username}{'dsttimeoffset'} || $dstoffset; $dst = 1; }
   } else {
   $heute = $date;
   $daterechnug = $date;
   }
	if ($iamguest) {
		$toffs   = $timeoffset;
		$dstoffs = $dstoffset;
	} else {
		$toffs   = ${$uid.$username}{'timeoffset'};
		$dstoffs = $userdst;
	}
	($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $dst) = gmtime($heute + (3600 * ($toffs + $dstoffs)));
   $year += 1900;
   @mon_days=(31,28,31,30,31,30,31,31,30,31,30,31);

   $view_selday = 1;
   if($INFO{'calyear'}) { 
   if($year == $INFO{'calyear'} && $mon == $INFO{'calmon'}-1) { $view_selday = 1; } else { $view_selday = 0; }
   $year =$INFO{'calyear'};
   $mon =$INFO{'calmon'}-1;
   }

#<--------------------------------------------->#
# Time/Days end
#<--------------------------------------------->#

#<--------------------------------------------->#
# Get Navi begin
#<--------------------------------------------->#

if(!$INFO{'calmon'}) { $INFO{'calmon'} = $mon+1; }
if(!$INFO{'calmon'} > 12) { $INFO{'calmon'} = 12; }

$next_mon =$INFO{'calmon'}+1;
$next_year =$year;
   $st_mon="$next_mon";
   if ($st_mon < 10) { $st_mon = "0$st_mon"; }
   $stnext="calmon_".$st_mon;
   $stnextname=$var_cal{$stnext};   
$last_mon =$INFO{'calmon'}-1;
   $st_mon="$last_mon";
   if ($st_mon < 10) { $st_mon = "0$st_mon"; }
   $stlast="calmon_".$st_mon;
   $stlastname=$var_cal{$stlast};   
$last_year =$year;
if ($INFO{'calmon'} == 12) { $next_mon =1; $next_year =$year+1;}
if ($INFO{'calmon'} == 1) { $last_mon =12; $last_year =$year-1;}
if ($next_mon < 10) { $next_mon = "0$next_mon";}
if ($last_mon < 10) { $last_mon = "0$last_mon";}
$next_link = qq~<a href="$scripturl?action=get_cal;calshow=1;calmon=$next_mon;calyear=$next_year;" title="$stnextname $next_year"> -</a>~;
$last_link = qq~<a href="$scripturl?action=get_cal;calshow=1;calmon=$last_mon;calyear=$last_year" title="$stlastname $last_year">- </a>~;

#<--------------------------------------------->#
# Get Navi end
#<--------------------------------------------->#

#<--------------------------------------------->#
# EventCal System begin
#<--------------------------------------------->#
   $viewyear = $year;
   $viewyear = substr($viewyear, 2,4);
   $days=@mon_days[$mon];
   ($wday1) = (localtime(timelocal(0, 0, 0, 1, $mon, $year)))[6];
   if($ShowSunday) {$wday1 = $wday1+1;}
   if ($wday1 == 0) { $wday1=7; }
   $mon++;
   $caltoday="$year".sprintf("%02d",$mon).sprintf("%02d",$mday);
   $st_mon="$mon";
   if ($st_mon < 10) { $st_mon = "0$st_mon"; }
   $st="calmon_".$st_mon;
   $view_mon =$mon;
   if ($view_mon < 10) { $view_mon = "0$view_mon"; }

if (!$Show_ColorLinks) {
	fopen(CALMEMBINFO, "$memberdir/memberinfo.txt");
	%eventmemberinf = map /(.*)\t(.*)/, <CALMEMBINFO>;
	fclose(CALMEMBINFO);
}

#<--------------------------------------------->#
# EventCal System end
#<--------------------------------------------->#

#<--------------------------------------------->#
# Add Events begin
#<--------------------------------------------->#


   $sdays="<select class=input name=selday size=1 style=\"height= 18px;\">";
   for ($i=1;$i<32;$i++) {
      $sel="";
      if ($mday == $i && !$sel_day) {
         $sel=" selected";
      }
      elsif ($sel_day == $i) {
	 $sel=" selected";
      }
      $sdays .= "<option value=".sprintf("%02d",$i)." $sel>$i</option>";
   }
   $sdays .= "</select>";
   $smonths="<select class=input name=selmon size=1 style=\"height= 18px;\">";
   for ($i=1;$i<13;$i++) {
      $sel="";
      if ($mon == $i && !$sel_mon) {
         $sel=" selected";
      }
      elsif ($sel_mon == $i) {
	 $sel=" selected";
      }
      $smonths .= "<option value=".sprintf("%02d",$i)." $sel>$i</option>";
   }

   $smonths .= "</select>";

   $syears="<select class=input name=selyear size=1 style=\"height= 18px;\">";

   for ($i=$year;$i<$year+4;$i++) {
      $sel="";
      if ($year == $i && !$sel_year) {
         $sel=" selected";
      }
      elsif ($sel_year == $i) {
	 $sel=" selected";
      }
      $syears .= "<option value=$i $sel>$i</option>";
   }

   $syears .= "</select>";

#<--------------------------------------------->#
# Add Events end
#<--------------------------------------------->#

#<--------------------------------------------->#
# GoTo begin
#<--------------------------------------------->#

   $gdays="<select class=input name=selday size=1 style=\"height= 18px;\">";
   $gdays .= "<option value=\"0\" selected>No</option>";
   for ($i=1;$i<32;$i++) {
      $sel="";
      $gdays .= "<option value=".sprintf("%02d",$i).">$i</option>";
   }
   $gdays .= "</select>";

$gyears3 = $year-3;
$gyears2 = $year-2;
$gyears1 = $year-1;
   $gyears="<select class=input name=selyear size=1 style=\"height= 18px;\">";
      $gyears .= "<option value=$gyears3>$gyears3</option>";
      $gyears .= "<option value=$gyears2>$gyears2</option>";
      $gyears .= "<option value=$gyears1>$gyears1</option>";

   for ($i=$year;$i<$year+4;$i++) {
      $sel="";
      if ($year == $i && !$sel_year) {
         $sel=" selected";
      }
      elsif ($sel_year == $i) {
	 $sel=" selected";
      }
      $gyears .= "<option value=$i $sel>$i</option>";
   }


   $gyears .= "</select>";


$calgotobox = qq~
	<form action="$scripturl?action=get_cal;calshow=1;calgotobox=1" method="post">
	<span class="small"><b>$var_cal{calsubmit}</b> $var_cal{calday} $gdays&nbsp;&nbsp; $var_cal{calmonth} $smonths &nbsp;&nbsp;$var_cal{calyear} $gyears &nbsp;&nbsp; <input type="submit" name="Go" value="Go" style="height= 18px;" />
	</form>
~;

#<--------------------------------------------->#
# GoTo end
#<--------------------------------------------->#

#<--------------------------------------------->#
# YaBBC Section begin
#<--------------------------------------------->#

if ($INFO{'addnew'} == 1) {
if ($INFO{'edit_cal_even'}) { $var_cal{calevent} = "$var_cal{'caledit'}:"; }
	if ($showsmdir eq 1) {
		opendir(DIR, "$smiliesdir");
		@contents = readdir(DIR);
		closedir(DIR);

		foreach $line (sort { uc($a) cmp uc($b) } @contents) {
			($name, $extension) = split(/\./, $line);
			if ($extension =~ /gif/i || $extension =~ /jpg/i || $extension =~ /jpeg/i || $extension =~ /png/i) {
				if ($line !~ /banner/i) {
					$moresmilieslist   .= qq~<a href="javascript:insert('[smiley=$line]', '')"><img src='$smiliesurl/$line' align='bottom' alt='$name' border='0'></a>$SmilieLinebreak[$i]~;
					$i++;
				}
			}
		}
	}

$calicon = "eventinfo";

## Edit Infos Begin ##
if ($INFO{'edit_typ'} == 0) { $aevt1       	         = ' selected="selected"'; }
elsif ($INFO{'edit_typ'} == 1)   { $aevt2                = ' selected="selected"'; }
elsif ($INFO{'edit_typ'} == 2)   { $aevt3                = ' selected="selected"'; }
else { $aevt2 = ' selected="selected"'; }
if ($INFO{'edit_typ1'} == 0) { $a1evt1	  	         = ' selected="selected"'; }
elsif ($INFO{'edit_typ1'} == 2)   { $a1evt2	         = ' selected="selected"'; }
elsif ($INFO{'edit_typ1'} == 3)   { $a1evt3              = ' selected="selected"'; }
else { $a1evt1 						 = ' selected="selected"'; }
if ($INFO{'edit_icon'}) {
$class = "calicon_$INFO{'edit_icon'}";
$$class = ' selected="selected"';
$calicon = "$INFO{'edit_icon'}";
}
if ($INFO{'edit_nonam'} == 1) { $cecknonam = "checked" }
## Edit Infos End ##

   $YaBBC_calout = qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
function calshowimage() {
   document.images.calicons.src="$modimgurl/EventCal/EventIcons/"+document.eventcal.calicon.options[document.eventcal.calicon.selectedIndex].value+".gif";
}
//-->
</script>
	<table width="100%" class="bordercolor" border="0" cellpadding="0" cellspacing="0">
<tr>
	<td width="100%" class="windowbg">
<b>$var_cal{calevent}</b><br />
<TABLE cellSpacing=0 cellPadding=0 border=0>
    <TR> 
      <TD width="140" height="23">
	<span class="small"><b>$var_cal{date}:</b></span>
      </TD>
      <TD>
	 <font size="1"> $sdays $var_cal{calday}&nbsp;&nbsp;$smonths $var_cal{calmonth} &nbsp;&nbsp;$syears $var_cal{calyear}
      </TD>
    </TR>
~;
if ($iamadmin || $CalEventPrivate == 1) { $option_private = qq~<option value="2"$aevt3>$var_cal{calprivate}</option>~; }
if ($iamadmin || $CalEventNoName == 1) { 
	$option_noname = qq~    <TR> 
      <TD width="140" height="23">
	<span class="small"><b>$var_cal{calnoname}:</b></span>
      </TD>
      <TD>
	 <input type=checkbox value="1" name="calnoname" $cecknonam/>
      </TD>
    </TR>~;
}
if ($CalEventNoName == 2) { $option_noname = ""; }
## funktion not jet ##<option value="1"$aevt4>$var_cal{eventinfo} ($var_cal{weekly})</option>##
   $YaBBC_calout .= qq~
$option_noname
    <TR> 
      <TD width="140" height="23">
	<span class="small"><b>$var_cal{calview}:</b></span>
      </TD>
      <TD> 
			<select name="caltype" size="1">
			<option value="0"$aevt1>$var_cal{calpublic}</option>
			<option value="1"$aevt2>$var_cal{calmembers}</option>
			$option_private
			</select> / 
			<select name="caltype2" size="1">
			<option value="0"$a1evt1>$var_cal{onlyone}</option>
			<option value="2"$a1evt2>$var_cal{eventinfo} ($var_cal{monthly})</option>
			<option value="3"$a1evt3>$var_cal{eventinfo} ($var_cal{yearly})</option>
			</select>
      </TD>
    </TR>
    <TR> 
      <TD  align="left" width="140" height="26">
	<span class="small"><b>$var_cal{event_icon}:</b></span>
      </TD>
      <TD><TABLE cellSpacing=0 cellPadding=0 border=0><TR><TD>
			<select name="calicon" onchange="calshowimage();">
			<option value="eventinfo"$calicon_eventinfo>$var_cal{eventinfo}</option>
			<option value="eventholiday"$calicon_eventholiday>$var_cal{eventholiday}</option>
			<option value="eventannounce"$calicon_eventannounce>$var_cal{eventannounce}</option>
			<option value="eventnote"$calicon_eventnote>$var_cal{eventnote}</option>
			<option value="eventparty"$calicon_eventparty>$var_cal{eventparty}</option>
			<option value="eventcelebration"$calicon_eventcelebration>$var_cal{eventcelebration}</option>
			<option value="eventsport"$calicon_eventsport>$var_cal{eventsport}</option>
			<option value="eventmedia"$calicon_eventmedia>$var_cal{eventmedia}</option>
			<option value="eventmeeting"$calicon_eventmeeting>$var_cal{eventmeeting}</option>
~;
if (-e("$vardir/eventcalIcon.txt"))  {
require "$vardir/eventcalIcon.txt";
	$i=0;
	while($CalIconURL[$i]) {
	if($INFO{'edit_icon'} eq $CalIconURL[$i]) { $eveic[$i] = " selected"; }
		$YaBBC_calout .= qq~<option value="$CalIconURL[$i]"$eveic[$i]>$CalIDescription[$i]\n~;
	$i++;
	}
}
$YaBBC_calout .= qq~
	</TD><TD>
			</select><img src="$modimgurl/EventCal/EventIcons/$calicon.gif" name="calicons" border="0" hspace="26" alt="" />
	</TABLE></TR></TD>
      </TD>
    </TR>
</TABLE>
	</td>
</tr>
<tr>
	<td width="100%" class="windowbg">
<TABLE>
<TR>
<TD>
<TABLE cellSpacing=0 cellPadding=0 border=0>
    <TR> 
      <TD><a href="javascript:insert('[url]', '[/url]')"><IMG src="$defaultimagesdir/url.gif" width=23 height=22 alt='$var_calpost{url}' title='$var_calpost{url}' border='0'></a></TD>
      <TD><a href="javascript:insert('[ftp]', '[/ftp]')"><IMG src="$defaultimagesdir/ftp.gif" width=23 height=22 alt='$var_calpost{ftp}' title='$var_calpost{ftp}' border='0'></a></TD>
      <TD><a href="javascript:insert('[img]', '[/img]')"><IMG src="$defaultimagesdir/img.gif" width=23 height=22 alt='$var_calpost{img}' title='$var_calpost{img}' border='0'></a></TD>
      <TD><a href="javascript:insert('[email]', '[/email]')"><IMG src="$defaultimagesdir/email2.gif" width=23 height=22 alt='$var_calpost{email}' title='$var_calpost{email}' border='0'></a></TD>
      <TD><a href="javascript:insert('[flash]', '[/flash]')"><IMG src="$defaultimagesdir/flash.gif" width=23 height=22 alt='$var_calpost{flash}' title='$var_calpost{flash}' border='0'></a></TD>
      <TD><a href="javascript:insert('[table]', '[/table]')"><IMG src="$defaultimagesdir/table.gif" width=23 height=22 alt='$var_calpost{table}' title='$var_calpost{table}' border='0'></a></TD>
      <TD><a href="javascript:insert('[tr]', '[/tr]')"><IMG src="$defaultimagesdir/tr.gif" width=23 height=22 alt='$var_calpost{tr}' title='$var_calpost{tr}' border='0'></a></TD>
      <TD><a href="javascript:insert('[td]', '[/td]')"><IMG src="$defaultimagesdir/td.gif" width=23 height=22 alt='$var_calpost{td}' title='$var_calpost{td}' border='0'></a></TD>
      <TD><a href="javascript:insert('[hr]', '')"><IMG src="$defaultimagesdir/hr.gif" width=23 height=22 alt='$var_calpost{hr}' title='$var_calpost{hr}' border='0'></a></TD>
      <TD><a href="javascript:insert('[tt]', '[/tt]')"><IMG src="$defaultimagesdir/tele.gif" width=23 height=22 alt='$var_calpost{tt}' title='$var_calpost{tt}' border='0'></a></TD>
      <TD><a href="javascript:insert('[code]', '[/code]')"><IMG src="$defaultimagesdir/code.gif" width=23 height=22 alt='$var_calpost{code}' title='$var_calpost{code}' border='0'></a></TD>
      <TD><a href="javascript:insert('[quote', '[/quote]')"><IMG src="$defaultimagesdir/quote2.gif" width=23 height=22 alt='$var_calpost{quote}' title='$var_calpost{quote}' border='0'></a></TD>
      <TD><a href="javascript:insert('[edit]', '[/edit]')"><IMG src="$defaultimagesdir/edit.gif" width=23 height=22 alt='$var_calpost{edit}' title='$var_calpost{edit}' border='0'></a></TD>
      <TD><a href="javascript:insert('[sup]', '[/sup]')"><IMG src="$defaultimagesdir/sup.gif" width=23 height=22 alt='$var_calpost{sup}' title='$var_calpost{sup}' border='0'></a></TD>
      <TD><a href="javascript:insert('[sub]', '[/sub]')"><IMG src="$defaultimagesdir/sub.gif" width=23 height=22 alt='$var_calpost{sub}' title='$var_calpost{sub}' border='0'></a></TD>
      <TD><a href="javascript:insert('[move]', '[/move]')"><IMG src="$defaultimagesdir/move.gif" width=23 height=22 alt='$var_calpost{move}' title='$var_calpost{move}' border='0'></a></TD>
      <TD><a href="javascript:insert('[timestamp=$date]', '')"><IMG src="$defaultimagesdir/timestamp.gif" width=23 height=22 alt='$var_calpost{timestamp}' title='$var_calpost{timestamp}' border='0'></a></TD>
    </TR><TR> 
      <TD><a href="javascript:insert('[b]', '[/b]')"><IMG src="$defaultimagesdir/bold.gif" width=23 height=22 alt='$var_calpost{bold}' title='$var_calpost{bold}' border='0'></a></TD>
      <TD><a href="javascript:insert('[i]', '[/i]')"><IMG src="$defaultimagesdir/italicize.gif" width=23 height=22 alt='$var_calpost{italicize}' title='$var_calpost{italicize}' border='0'></a></TD>
      <TD><a href="javascript:insert('[u]', '[/u]')"><IMG src="$defaultimagesdir/underline.gif" width=23 height=22 alt='$var_calpost{underline}' title='$var_calpost{underline}' border='0'></a></TD>
      <TD><a href="javascript:insert('[s]', '[/s]')"><IMG src="$defaultimagesdir/strike.gif" width=23 height=22 alt='$var_calpost{strike}' title='$var_calpost{strike}' border='0'></a></TD>
      <TD><a href="javascript:insert('[highlight]', '[/highlight]')"><IMG src="$defaultimagesdir/highlight.gif" width=23 height=22 alt='$var_calpost{highlight}' title='$var_calpost{highlight}' border='0'></a></TD>
      <TD colspan=4><select onchange="insert('[font=' + this.value + ']', '[/font]');"; style="width: 93px; margin-top: 2px; margin-left: 2px; margin-right: 1px; font-size: 9px;">
          <option value="Verdana">Verdana</option>
          <option value="">-----</option>
          <option value="Sans-Serif">Sans-Serif</option>
          <option value="Verdana" style="font-family: Verdana" selected="selected">Verdana</option>
          <option value="Arial" style="font-family: Arial">Arial</option>
          <option value="Serif" style="font-family: Serif">Serif</option>
          <option value="Courier" style="font-family: Courier">Courier</option>
          <option value="Courier New" style="font-family: Courier New">Courier New</option>
          <option value="Fantasy" style="font-family: Fantasy">Fantasy</option>
          <option value="monospace" style="font-family: monospace">Monospace</option>
          </select>
      </TD>
      
      <TD colspan=2><select onchange="insert('[size=' + this.value + ']', '[/size]');"; style="width: 43px; margin-top: 2px; margin-left: 1px; margin-right: 2px; font-size: 9px;">
          <option value="">11</option>
          <option value="">--</option>
          <option value="6">6</option>
          <option value="7">7</option>
          <option value="8">8</option>
          <option value="9">9</option>
          <option value="10">10</option>
          <option value="11" selected="selected">11</option>
          <option value="12">12</option>
          <option value="14">14</option>
          <option value="16">16</option>
          <option value="18">18</option>
          <option value="20">20</option>
          <option value="22">22</option>
          <option value="24">24</option>
          <option value="36">36</option>
          <option value="48">48</option>
          <option value="56">56</option>
          <option value="72">72</option>
          </select>
       </TD>    
      <TD><a href="javascript:insert('[code]', '[/code]')"><IMG src="$defaultimagesdir/pre.gif" width=23 height=22 alt='$var_calpost{pre}' title='$var_calpost{pre}' border='0'></a></TD>
      <TD><a href="javascript:insert('[quote', '[/quote]')"><IMG src="$defaultimagesdir/left.gif" width=23 height=22 alt='$var_calpost{left}' title='$var_calpost{left}' border='0'></a></TD>
      <TD><a href="javascript:insert('[edit]', '[/edit]')"><IMG src="$defaultimagesdir/center.gif" width=23 height=22 alt='$var_calpost{center}' title='$var_calpost{center}' border='0'></a></TD>
      <TD><a href="javascript:insert('[sup]', '[/sup]')"><IMG src="$defaultimagesdir/right.gif" width=23 height=22 alt='$var_calpost{right}' title='$var_calpost{right}' border='0'></a></TD>
      <TD><a href="javascript:insert('[sub]', '[/sub]')"><IMG src="$defaultimagesdir/list.gif" width=23 height=22 alt='$var_calpost{list}' title='$var_calpost{list}' border='0'></a></TD>
      <TD><a href="javascript:insert('me/', '')"><IMG src="$defaultimagesdir/me.gif" width=23 height=22 alt='$var_calpost{me}' title='$var_calpost{me}' border='0'></a></TD>
    </TR>
</TABLE>
</TD>
<TD>
        <script language="JavaScript1.2" type="text/javascript">
        <!--
          img1 = new Image();
          img1.src = "$defaultimagesdir/palette.gif";
        //-->
        </script>
        <div style="height: 42px; width: 86px; overflow: auto; border: 1px; border-style: outset; float: right;">
        ~;
		for ($z = 0; $z < 256; $z += 51) {
			$c3 = sprintf("%02x", $z);
			for ($y = 0; $y < 256; $y += 51) {
				$c2 = sprintf("%02x", $y);
				for ($x = 0; $x < 256; $x += 51) {
					$c1 = sprintf("%02x", $x);
					$selcolor = qq~#$c1$c2$c3~;
					if ($ENV{'HTTP_USER_AGENT'} =~ /Safari/) { $YaBBC_calout .= qq~<a href="javascript:insert('[color=$selcolor]', '[/color]')"><span style="background-color: $selcolor; width: 11px; height: 11px;"><img src="$defaultimagesdir/palette.gif" border="0" hspace="0" vspace="0" alt="" style="height: 11px; width: 11px; margin: 0px;" /></span></a>~; }
					else { $YaBBC_calout .= qq~<a href="javascript:insert('[color=$selcolor]', '[/color]')"><span style="float: left; background-color: $selcolor; width: 9px; height: 9px; border: 1px outset; font-size: 5px;">&nbsp;</span></a>~; }
				}
				if ($ENV{'HTTP_USER_AGENT'} =~ /Safari/) { $YaBBC_calout .= qq~<br />~; }
			}
		}
		$YaBBC_calout .= qq~
        </div>
</TD>
</TR>
</TABLE>
</td>
</tr><tr>
   <td width="100%" class="windowbg">
      <a href="javascript:insert(':)', '')"><img src='$imagesdir/smiley.gif' alt='$var_calpost{smiley}' title='$var_calpost{smiley}' border='0'></a>
      <a href="javascript:insert(';)', '')"><img src='$imagesdir/wink.gif' alt='$var_calpost{wink}' title='$var_calpost{wink}' border='0'></a>
      <a href="javascript:insert(':D', '')"><img src='$imagesdir/cheesy.gif' alt='$var_calpost{cheesy}' title='$var_calpost{cheesy}' border='0'></a>
      <a href="javascript:insert(';D', '')"><img src='$imagesdir/grin.gif' alt='$var_calpost{grin}' title='$var_calpost{grin}' border='0'></a>
      <a href="javascript:insert('>:(', '')"><img src='$imagesdir/angry.gif' alt='$var_calpost{angry}' title='$var_calpost{angry}' border='0'></a>
      <a href="javascript:insert(':(', '')"><img src='$imagesdir/sad.gif' alt='$var_calpost{sad}' title='$var_calpost{sad}' border='0'></a>
      <a href="javascript:insert(':o', '')"><img src='$imagesdir/shocked.gif' alt='$var_calpost{shocked}' title='$var_calpost{shocked}' border='0'></a>
      <a href="javascript:insert('8-)', '')"><img src='$imagesdir/cool.gif' alt='$var_calpost{cool}' title='$var_calpost{cool}' border='0'></a>
      <a href="javascript:insert(':-?', '')"><img src='$imagesdir/huh.gif' alt='$var_calpost{huh}' title='$var_calpost{huh}' border='0'></a>
      <a href="javascript:insert('::)', '')"><img src='$imagesdir/rolleyes.gif' alt='$var_calpost{rolleyes}' title='$var_calpost{rolleyes}' border='0'></a>
      <a href="javascript:insert(':P', '')"><img src='$imagesdir/tongue.gif' alt='$var_calpost{tongue}' title='$var_calpost{tongue}' border='0'></a>
      <a href="javascript:insert(':-[', '')"><img src='$imagesdir/embarassed.gif' alt='$var_calpost{embarassed}' title='$var_calpost{embarassed}' border='0'></a>
      <a href="javascript:insert(':-X', '')"><img src='$imagesdir/lipsrsealed.gif' alt='$var_calpost{lipsrsealed}' title='$var_calpost{lipsrsealed}' border='0'></a>
      <a href="javascript:insert(':-/', '')"><img src='$imagesdir/undecided.gif' alt='$var_calpost{undecided}' title='$var_calpost{undecided}' border='0'></a>
      <a href="javascript:insert(':-*', '')"><img src='$imagesdir/kiss.gif' alt='$var_calpost{kiss}' title='$var_calpost{kiss}' border='0'></a>
      <a href="javascript:insert(':`(', '')"><img src='$imagesdir/cry.gif' alt='$var_calpost{cry}' title='$var_calpost{cry}' border='0'></a>
      $moresmilieslist
   </td>
</tr><tr>
   <td width="100%" class="windowbg">
~;
if (!$INFO{'edit_cal_even'}) {
$YaBBC_calout .= qq~
	<textarea class=input name=calevent style="width:590px; height:50px;"></textarea>
	<br /><br />
	<input class=button type=submit name=calsubmit value="$var_calpost{event_send}"  accesskey="s">
	<br /> </font>
   </td>
</tr>
</form>
</table>
~;
}
} else {
   $YaBBC_calout = qq~
	<table width="100%" class="bordercolor" border="0" cellpadding="0" cellspacing="0">
	<tr>
		<td width="100%" class="windowbg2">
		<span class="small"> <img src="$modimgurl/EventCal/eventmore.gif" border="0" alt="$var_calpost{getaddevent}" /> <a href="$scripturl?action=get_cal;calshow=1;addnew=1">$var_calpost{getaddevent}</a></span>
		</td>
	</tr>
	</table>
~;
}

#<--------------------------------------------->#
# YaBBC Section end
#<--------------------------------------------->#

#<--------------------------------------------->#
# Event data begin
#<--------------------------------------------->#

	fopen(EVENTDATA, "+<$vardir/eventcal.db");
	seek EVENTDATA,0,0;
	my @caldata1 = <EVENTDATA>;
	fclose(EVENTDATA);

	if ($INFO{'eventdate'}) { $bd_year= substr($INFO{'eventdate'},0,4); } else { $bd_year= $year; }

## Get Birthdays ##
	if ($Show_EventBirthdays == 1) {
	if (!-e("$vardir/eventcalbday.db"))  { &calupdatebday; }
		fopen(EVENTBIRTH, "$vardir/eventcalbday.db");
		seek EVENTBIRTH,0,0;
		my @birthmembers = <EVENTBIRTH>;
		fclose(EVENTBIRTH);

		foreach $user_name (@birthmembers) {
			chomp $user_name;
			($user_bdyear, $user_bdmon, $user_bdday, $user_bdname) = split(/\|/,$user_name);
	 		if ((($user_bdmon < $view_mon) || ($user_bdmon == $view_mon) && ($user_bdday < $mday)) && (!$INFO{'showmini'})) {
			$bd_y = $year + 1; 
			$bday_date ="$bd_y$user_bdmon$user_bdday";
			$age = $bd_y-$user_bdyear; 
			} else { 
			$bd_y = $bd_year; 
			$bday_date ="$bd_y$user_bdmon$user_bdday";
			$age = $bd_y-$user_bdyear; 
			}

			$string1 = qq~<span class="small">$age</span>~;
			$string = qq~$bday_date|0|$user_bdname|$bdayoutput|$string1|birthday|0\n~;

		%{bday.$bd_year.$user_bdmon.$user_bdday}=(
		'caleventdate' => "$bd_year$user_bdmon$user_bdday",
		'calyear' => "$bd_year",
		'calmon' => "$user_bdmon",
		'calday' => "$user_bdday",
		'caltype' => "0",
		'calname' => "$user_bdname",
		'caltime' => "$bdayoutput",
		'calicon' => "birthday",
		'calevent' => "$string",
		'calnoname' => "0",
		);

		push (@caldata3, $string);

		}

	}

## Get Events ##
	@caldata2 = sort (@caldata1);
	foreach my $eventline (@caldata2) {
		chomp $eventline;
		($cal_date,$cal_type,$cal_name,$cal_time,$cal_event,$cal_icon,$cal_noname,$cal_type2) = split(/\|/,$eventline);
		$c_year=substr($cal_date,0,4);
		$c_mon=substr($cal_date,4,2);
		$c_day=substr($cal_date,6,2);

		if (($cal_type == 2) && ($cal_name ne $username)) { next;}
		if($cal_icon eq "") { $cal_icon = "eventinfo"; }
		if($cal_type2 == 2) { 
		$c_mon = $st_mon;
		$c_year = $bd_year;
	 	if (($c_mon < $view_mon) || ($c_mon == $view_mon) && ($c_day < $mday) && (!$INFO{'calmon'})) {
		$cd_year = $bd_year + 1;
		} else {
		$cd_year = $bd_year;
		}
		$cal_date = "$cd_year$st_mon$c_day";
		} else { 
		$cal_date = "$cal_date";
		}
		if($cal_type2 == 3) {
		$c_year = $bd_year;
	 	if (($c_mon < $view_mon) || ($c_mon == $view_mon) && ($c_day < $mday) && (!$INFO{'calmon'})) {
		$cd_year = $bd_year + 1;
		} else {
		$cd_year = $bd_year;
		}
		$cal_date = "$cd_year$c_mon$c_day";
		} else { 
		$cal_date = "$cal_date";
		}
		if (($cal_type == 2) && ($cal_name eq $username)) { %{private.$c_year.$c_mon.$c_day.$username.$cal_type}=('private' => "$cal_type",); }
		if ($CalEventNoName == 2) { $cal_noname = 1; } 
		else { $cal_noname = $cal_noname; }
		$string2 = qq~$cal_date|$cal_type|$cal_name|$cal_time|$cal_event|$cal_icon|$cal_noname|$cal_type2\n~;

		%{event.$c_year.$c_mon.$c_day}=(
		'caleventdate' => "$cal_date",
		'calyear' => "$c_year",
		'calmon' => "$c_mon",
		'calday' => "$c_day",
		'caltype' => "$cal_type",
		'calname' => "$cal_name",
		'caltime' => "$cal_time",
		'calicon' => "$cal_icon",
		'calevent' => "$cal_event",
		'calnoname' => "$cal_noname",
		'caltype2' => "$cal_type2",
		);

		push (@caldata3, $string2);

	}

#<--------------------------------------------->#
# Event data end
#<--------------------------------------------->#

#<--------------------------------------------->#
# Show/Edit Events begin
#<--------------------------------------------->#

if ($INFO{'showthisdate'} || $INFO{'showmini'} || $INFO{'edit_cal_even'}) {

$event_id = "$INFO{'calid'}";
$event_date ="$INFO{'eventdate'}";
	 $d_year=substr($event_date,0,4);
	 $d_mon=substr($event_date,4,2);
	 $d_day=substr($event_date,6,2);
	 $monst="calmon_".$d_mon;

	 $cname = ${event.$d_year.$d_mon.$d_day}{'calname'} || ${bday.$d_year.$d_mon.$d_day}{'calname'};
	 if ($mytimeselected == 1) {
		$cdate="$d_day/$d_mon/$d_year";
	 } elsif ($mytimeselected == 2) {
		$cdate="$d_day.$d_mon.$d_year";
	 } elsif ($mytimeselected == 3) {
		$cdate="$d_day.$d_mon.$d_year";
	 } elsif ($mytimeselected == 4) {
		$cdate="$var_cal{$monst} $d_day, $d_year";
	 } elsif ($mytimeselected == 5) {
		$cdate="$d_mon/$d_day/$d_year";
	 } elsif ($mytimeselected == 6) {
		$cdate="$d_day $var_cal{$monst}, $d_year";
	 } else {
		$cdate="$d_day-$d_mon-$d_year";

	 }


if ($INFO{'showmini'}) {

$yymain .= qq~
<div class="seperator">
<table cellpadding="4" cellspacing="1" border="0" width="100%">
	<tr>
		<td align="left" class="catbg">
		<div style="float: left; width: 30%; padding-top: 5px; padding-bottom: 5px; text-align: left;"><img src="$modimgurl/EventCal/eventcal.gif" border="0" alt="" /> $var_cal{'caltitle'}</div>
		<div style="float: left; width: 70%; padding-top: 4px; padding-bottom: 4px; text-align: right;">$calgotobox</div>
		</td>
	</tr>
</table>
</div>
<br />
<table border=0 width="100%" cellspacing="0" cellpadding="0" class="bordercolor">
  <tr>
    <td>
<table cellpadding="4" cellspacing="1" border="0" width="100%">
~;

@calday = sort (@caldata3);

foreach $cal_events (@calday) {
	chomp $cal_events;
	my ($cdat,$ctyp,$cnam,$ctim,$ceve,$cico,$cnonam,$ctyp2) = split(/\|/, $cal_events);
	if (!$Show_ColorLinks) {
	($memrealname, $dummy, $dummy, $dummy, $dummy) = split(/\|/, $eventmemberinf{$cnam});
	}
	if (($ctyp == 1) && $iamguest) { next; }
	if (($ctyp == 2) && ($cnam ne $username)) { next; }
	$dd_year=substr($cdat,0,4);
	$dd_mon=substr($cdat,4,2);
	$dd_day=substr($cdat,6,2);
	if($ctyp2 == 2) { $cdat = "$bd_year$d_mon$dd_day"; $eventfound = 1; } else { $cdat = "$cdat"; }
	if($ctyp2 == 3) { $cdat = "$bd_year$dd_mon$dd_day"; $eventfound = 1; } else { $cdat = "$cdat"; }
	$delete_event = "";
	$edit_event = "";
	$icon_text = "$var_cal{$cico}";
	if(!$var_cal{$cico}) { $icon_text = &calicontext($cico); }
	$message = $ceve;
	if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC;
	$event_message = $message;

if (($event_date == $cdat) && (!$INFO{'edit_cal_even'})) {
	if ($Show_ColorLinks) {
	 	&LoadUser($cnam);
		$eventuserlink = $link{$cnam};
		$eventbduserlink = $eventuserlink;
	} else {
		$user_linkname = $memrealname;
		$eventuserlink = qq~<a href="$scripturl?action=viewprofile;username=$cnam">$user_linkname</a>~;
		$eventbduserlink = $eventuserlink;
	}
	if (($CalEventNoName == 1) && ($cnonam == 1) && ($iamadmin || $iamgmod)) { $cnonam = 0; } else { $cnonam = $cnonam; }
	if ($cnonam == 1) { $eventuserlink = ""; } else { $eventuserlink = "($eventuserlink)";}

	if ($cico eq "birthday") {
	$yymain .= qq~
	<tr>
		<td align="left" colspan="2" class="windowbg2">
			<img src="$modimgurl/EventCal/EventIcons/eventbd.gif" border="0" alt="$var_cal{calbirthday}" /> $cdate <b>$var_cal{calbirthday}</b>
		</td>
	</tr>
	<tr>
		<td align="left" colspan="2" class="windowbg">
			<b>$var_cal{'calsubtitle'}:</b><br /> <br />
			$eventbduserlink $var_cal{calis} $ceve $var_cal{calold}<br/><br/>
		</td>
	</tr>
~;
	} else {
	$yymain .= qq~
	<tr>
		<td align="left" colspan="2" class="windowbg2">
~;
if ($ctyp == 2) {
	$yymain .= qq~
			<img src="$modimgurl/EventCal/EventIcons/eventprivate.gif" border="0" alt="Event" /> <img src="$modimgurl/EventCal/EventIcons/$cico.gif" border="0" alt="$icon_text" /> $cdate <b>$icon_text</b> $eventuserlink
~;
	} else {
	$yymain .= qq~
			<img src="$modimgurl/EventCal/EventIcons/$cico.gif" border="0" alt="$icon_text" /> $cdate <b>$icon_text</b> $eventuserlink
~;
	}
	$yymain .= qq~
		</td>
	</tr>
	<tr>
		<td align="left" colspan="2" class="windowbg">
			<b>$var_cal{'calsubtitle'}:</b><br /> <br />
			$event_message<br/><br/>
		</td>
	</tr>
	<tr>
~;

        if (("$username" eq "$cnam") || ($iamadmin || $iamgmod)) {
		if (!$iamguest) {
	$yymain .= qq~
		<td align="left" with=50% class="windowbg">
			<a href="$scripturl?action=get_cal;calshow=1;eventdate=$cdat;calid=$ctim;edit_cal_even=1;addnew=1;edit_typ=$ctyp;edit_icon=$cico;edit_nonam=$cnonam;edit_typ1=$ctyp2" title='$var_cal{'caledit'}'><IMG src="$defaultimagesdir/modify.gif" alt='$var_cal{'caledit'}' title='$var_cal{'caledit'}' border='0'> $var_cal{'caledit'}</a>&nbsp;&nbsp;&nbsp;<a href="$scripturl?action=del_cal;caldel=1;calid=$ctim" title='$var_cal{'caldel'}'><IMG src="$defaultimagesdir/delete.gif" alt='$var_cal{'caldel'}' title='$var_cal{'caldel'}' border='0'> $var_cal{'caldel'}</a>
		</td>
~;
	  	}
        } else {
	$yymain .= qq~
		<td align="left" with=50% class="windowbg">
		</td>
~;
	}
}

	$yymain .= qq~
	</tr>
~;
}
}

if ((!exists(${event.$d_year.$d_mon.$d_day}{'calday'})) && (!$eventfound) && (!exists(${bday.$d_year.$d_mon.$d_day}{'calday'}))) {
         $yymain .= qq~<TABLE><TR><TD width=100% valign=top><HR class="hr" size="1"><img src="$modimgurl/EventCal/EventIcons/eventinfo.gif" border="0" alt="Event" /> $var_cal{calnoevent}<HR class="hr" size="1"></TD></TR></TABLE>~;
}

$yymain .= qq~
</table>
</td>
</tr>
</table>
~;


	$yytitle = $var_cal{yytitle};
	&template;
	exit;
}



## Show Edit Events ##

if ($INFO{'edit_cal_even'} || $INFO{'showthisdate'}) {

$yymain .= qq~
<div class="seperator">
<table cellpadding="4" cellspacing="1" border="0" width="100%">
	<tr>
		<td align="left" class="catbg">
		<div style="float: left; width: 30%; padding-top: 5px; padding-bottom: 5px; text-align: left;"><img src="$modimgurl/EventCal/eventcal.gif" border="0" alt="" /> $var_cal{'caltitle'}</div>
		<div style="float: left; width: 70%; padding-top: 4px; padding-bottom: 4px; text-align: right;">$calgotobox</div>
		</td>
	</tr>
</table>
</div>
<br />
<table border=0 width="100%" cellspacing="0" cellpadding="0" class="bordercolor">
  <tr>
    <td>
<table cellpadding="4" cellspacing="1" border="0" width="100%">
~;

@calday = sort (@caldata3);
foreach $cal_events (@calday) {
	chomp $cal_events;
	my ($cdat,$ctyp,$cnam,$ctim,$ceve,$cico,$cnonam,$ctyp2) = split(/\|/, $cal_events);
	if (!$Show_ColorLinks) {
	($memrealname, $dummy, $dummy, $dummy, $dummy) = split(/\|/, $eventmemberinf{$cnam});
	}
	if (($ctyp == 1) && $iamguest) { next; }
	if (($ctyp == 2) && ($cnam ne $username)) { next; }
	if($cico eq "") { $cico = "eventinfo"; }
	$dd_year=substr($cdat,0,4);
	$dd_mon=substr($cdat,4,2);
	$dd_day=substr($cdat,6,2);
	if($ctyp2 == 2) { $cdat = "$d_year$d_mon$dd_day"; $eventfound = 1; } else { $cdat = "$cdat"; }
	if($ctyp2 == 3) { $cdat = "$d_year$dd_mon$dd_day"; $eventfound = 1; } else { $cdat = "$cdat"; }
	$delete_event = "";
	$edit_event = "";
	$icon_text = "$var_cal{$cico}";
	if(!$var_cal{$cico}) { $icon_text = &calicontext($cico); }
	$message = $ceve;
	if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC;
	$event_message = $message;

if ($event_id == $ctim && $cdat == $event_date) {
	if ($Show_ColorLinks) {
	 	&LoadUser($cnam);
		$eventuserlink = $link{$cnam};
		$eventbduserlink = $eventuserlink;
	} else {
		$user_linkname = $memrealname;
		$eventuserlink = qq~<a href="$scripturl?action=viewprofile;username=$cnam">$user_linkname</a>~;
		$eventbduserlink = $eventuserlink;
	}
	if (($CalEventNoName == 1) && ($cnonam == 1) && ($iamadmin || $iamgmod)) { $cnonam = 0; } else { $cnonam = $cnonam; }
	if ($cnonam == 1) { $eventuserlink = ""; } else { $eventuserlink = "($eventuserlink)";}

	if ($cico eq "birthday" && $cdat == $event_date) {
	$yymain .= qq~
	<tr>
		<td align="left" colspan="2" class="windowbg2">
			<img src="$modimgurl/EventCal/EventIcons/eventbd.gif" border="0" alt="$var_cal{calbirthday}" /> $cdate <b>$var_cal{calbirthday}</b>
		</td>
	</tr>
	<tr>
		<td align="left" colspan="2" class="windowbg">
			<b>$var_cal{'calsubtitle'}:</b><br /> <br />
			$eventbduserlink $var_cal{calis} $ceve $var_cal{calold}<br/><br/>
		</td>
	</tr>
	<tr>
		<td align="left" with=50% class="windowbg">
		
		</td>
	</tr>
~;
	} else {
	$yymain .= qq~
	<tr>
		<td align="left" colspan="2" class="windowbg2">
~;
if ($ctyp == 2) {
	$yymain .= qq~
			<img src="$modimgurl/EventCal/EventIcons/eventprivate.gif" border="0" alt="Event" /> <img src="$modimgurl/EventCal/EventIcons/$cico.gif" border="0" alt="$icon_text" /> $cdate <b>$icon_text</b> $eventuserlink
~;
	} else {
	$yymain .= qq~
			<img src="$modimgurl/EventCal/EventIcons/$cico.gif" border="0" alt="$icon_text" /> $cdate <b>$icon_text</b> $eventuserlink
~;
	}
	$yymain .= qq~
		</td>
	</tr>
	<tr>
		<td align="left" colspan="2" class="windowbg">
			<b>$var_cal{'calsubtitle'}:</b><br /> <br />
			$event_message<br/><br/>
		</td>
	</tr>
	<tr>
~;

        if (("$username" eq "$cnam" || $iamadmin || $iamgmod) && (!$INFO{'edit_cal_even'})) {
		if (!$iamguest) {
	$yymain .= qq~
		<td align="left" with=50% class="windowbg">
			<a href="$scripturl?action=get_cal;calshow=1;eventdate=$cdat;calid=$ctim;edit_cal_even=1;addnew=1;edit_typ=$ctyp;edit_icon=$cico;edit_nonam=$cnonam;edit_typ1=$ctyp2" title='$var_cal{'caledit'}'><IMG src="$defaultimagesdir/modify.gif" alt='$var_cal{'caledit'}' title='$var_cal{'caledit'}' border='0'> $var_cal{'caledit'}</a>&nbsp;&nbsp;&nbsp;<a href="$scripturl?action=del_cal;caldel=1;calid=$ctim" title='$var_cal{'caldel'}'><IMG src="$defaultimagesdir/delete.gif" alt='$var_cal{'caldel'}' title='$var_cal{'caldel'}' border='0'> $var_cal{'caldel'}</a>
		</td>
~;
	  	}
        } else {
	$yymain .= qq~
		<td align="left" with=50% class="windowbg">
		</td>
~;
	}
}

$yymain .= qq~
	</tr>
</table>
</td>
</tr>
</table>
~;

if (($INFO{'edit_cal_even'}) && ("$username" eq "$cnam" || $iamadmin || $iamgmod)) {

	$editmessage = qq~$ceve~;
	$editmessage =~ s~<\/~\&lt\;/~isg;
	$editmessage =~ s~<br />~\n~g;
	$editmessage =~ s/ \&nbsp; \&nbsp; \&nbsp;/\t/ig;
	&ToChars($editmessage);

$yymain .= qq~
<div class="seperator">
<table cellpadding="4" cellspacing="1" border="0" width="100%">
	<tr>
		<td align="left" class="catbg">
			<IMG src="$defaultimagesdir/modify.gif" alt='$var_cal{'caledit'}' title='$var_cal{'caledit'}' border='0'> $var_cal{'caledit'}
		</td>
	</tr>
	<tr>
		<td class="windowbg">
	<form action="$scripturl?action=add_cal" name=eventcal method="post">
	<script type="text/javascript" src="$modimgurl/EventCal/eventcal.js" language="JavaScript"></script>
	$YaBBC_calout
~;
$yymain .= qq~
	<textarea class=input name=calevent style="width:590px; height:50px;">$editmessage</textarea>
	<br /><br />
	<input type="hidden" name="editid" value="$event_id" />
	<input class=button type=submit name=calsubmit value="$var_cal{'caledit'}"  accesskey="s">
	<br /> </font>
   </td>
</tr>
</form>
</table>
		</td>
	</tr>
</table>
</div>
~;

}
}
}


	$yytitle = $var_cal{yytitle};
	&template;
	exit;
}

}

#<--------------------------------------------->#
# Show/Edit Events end
#<--------------------------------------------->#

#<--------------------------------------------->#
# Print Events begin
#<--------------------------------------------->#

   $outstring  = qq~ ~;
   if ($Scroll_Events == 1) {
   $outstring .= "<A name=\"scroller\"></A><MARQUEE behavior=\"scroll\" direction=\"up\" height=\"130\" scrollamount=\"1\" scrolldelay=\"1\" onmouseover='this.stop()' onmouseout='this.start()'>";
   } elsif ($Scroll_Events == 2) {
   $outstring .= "<div style='overflow:auto;height:150px;'>";
   }
   $outstring .= "<TABLE width=90% border=0>";
   if (!$DisplayEvents) { $DisplayEvents = 0;}
   @caldata4 = sort (@caldata3);
   foreach $cal_events (@caldata4) {
   chomp $cal_events;
      my ($cdate,$ctype,$cname,$ctime,$cevent,$cicon,$cnoname,$ctype2) = split(/\|/, $cal_events);
	if (!$Show_ColorLinks) {
	($memrealname, $dummy, $dummy, $dummy, $dummy) = split(/\|/, $eventmemberinf{$cname});
	}
         $cyear=substr($cdate,0,4);
         $cmon=substr($cdate,4,2);
         $cday=substr($cdate,6,2);
	 $monst="calmon_".$cmon;
	 if (($DisplayEvents > 0) && (!$INFO{'calyear'})) {
	 ($dummy,$dummy,$dummy,$d_cal,$m_cal,$y_cal,$dummy,$dummy,$dummy) = gmtime($daterechnug + (86400*$DisplayEvents));
   	 $y_cal += 1900;
	 $m_cal = $m_cal + 1;
	 if ($m_cal < 10) { $m_cal = "0$m_cal"; }
	 if (($m_cal < $view_mon) || (($m_cal == $view_mon) && ($d_cal < $mday))) { 
			$y_cal = $bd_year + 1; 
	 } else { 
			$y_cal = $bd_year; 
	 }
	 $caleventbegin="$year".sprintf("%02d",$mon).sprintf("%02d",$mday);
	 $caleventend="$y_cal".sprintf("%02d",$m_cal).sprintf("%02d",$d_cal);
	 if (($cdate >= $caleventbegin) && ($cdate <= $caleventend)) { $event_found = 1; } else { $event_found = 0;}
	 if ($DisplayEvents == 1) { $event_index = qq~$var_cal{caltoday} $var_cal{calsubtitle}:~; } else { $event_index = qq~$var_cal{calcoming} $var_cal{calsubtitle} ($DisplayEvents $var_cal{caldays}):~; }
	 } else {
	 if ($view_mon == $cmon && $year == $cyear) { $event_found = 1; } else { $event_found = 0;}
	 if (($INFO{'calyear'}) || ($DisplayEvents == 0)) { $event_index = qq~$var_cal{$st} $year - $var_cal{calsubtitle}:~; }
	 }

	 if($cicon eq "") { $cico = "eventinfo"; }
	 if (($CalShortEvent) && (length($cevent) > $CalShortEvent)) {
		unless ($ctime eq "birthday") {
	 	$ceventshort = substr($cevent,0,$CalShortEvent);
	 	$cevent = substr($ceventshort, 0, rindex($ceventshort,' '));
		$cevent .= qq~ ... <br /><br /><a href="$scripturl?action=get_cal;calshow=1;eventdate=$cyear$cmon$cday;calid=$ctime;showthisdate=1" title="$var_cal{'calshowevent'}"><font color="#FF6600">$var_cal{calmore}</font> <img src="$modimgurl/EventCal/eventmore.gif" border="0" alt="$var_cal{'calshowevent'}" /></a>~;
		}
	 }
	 $message = $cevent;
	 if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC;
	 $cevent = $message;

      if ($event_found == 1) {
	 if ($mytimeselected == 1) {
		$cdate="$cday/$cmon/$cyear";
	 } elsif ($mytimeselected == 2) {
		$cdate="$cday.$cmon.$cyear";
	 } elsif ($mytimeselected == 3) {
		$cdate="$cday.$cmon.$cyear";
	 } elsif ($mytimeselected == 4) {
		$cdate="$var_cal{$monst} $cday, $cyear";
	 } elsif ($mytimeselected == 5) {
		$cdate="$cmon/$cday/$cyear";
	 } elsif ($mytimeselected == 6) {
		$cdate="$cday $var_cal{$monst}, $cyear";
	 } else {
		$cdate="$cday-$cmon-$cyear";
	 }
         $cdate="<a href=\"$scripturl?action=get_cal;calshow=1;eventdate=$cyear$cmon$cday;calid=$ctime;showthisdate=1\"  title=\"$var_cal{'calshowevent'}\">".$cdate."</a>";
         if (($ctype == 1) && $iamguest) { next; }
	 if (($ctype == 2) && ($cname ne $username)) { next; }
	 $cal_time = &stringtotime( $ctime );
	 $icon_text = "$var_cal{$cicon}";
	 if(!$var_cal{$cicon}) { $icon_text = &calicontext($cicon); }
	 if ($Show_ColorLinks) {
	 	&LoadUser($cname);
		$eventuserlink = $link{$cname};
		$eventbduserlink = $eventuserlink;
	 } else {
		$user_linkname = $memrealname;
		$eventuserlink = qq~<a href="$scripturl?action=viewprofile;username=$cname">$user_linkname</a>~;
		$eventbduserlink = $eventuserlink;
	 }
	 if (($CalEventNoName == 1) && ($cnoname == 1) && ($iamadmin || $iamgmod)) { $cnoname = 0; } else { $cnoname = $cnoname; }
	 if ($cnoname == 1) { $eventuserlink = ""; } else { $eventuserlink = "($eventuserlink)";}
	 if ($cicon eq "birthday") {
	 $outstring .="<TR><TD width=100% valign=top><span class=\"small\"><img src=\"$modimgurl/EventCal/EventIcons/eventbd.gif\" border=\"0\" alt=\"$var_cal{calbirthday}\" /> $cdate <b>$var_cal{calbirthday}</b><br /> $eventbduserlink $var_cal{calis} $cevent $var_cal{calold}<HR class=\"hr\" size=\"1\"></span></TD></TR>";
	 } elsif ($ctype == 2) {
         $outstring .="<TR><TD width=100% valign=top><span class=\"small\"><img src=\"$modimgurl/EventCal/EventIcons/eventprivate.gif\" border=\"0\" alt=\"$var_cal{'calprivate'} Event\" /> <img src=\"$modimgurl/EventCal/EventIcons/$cicon.gif\" border=\"0\" alt=\"$icon_text\" /> $cdate <b>$icon_text</b> $eventuserlink<br />$cevent<HR class=\"hr\" size=\"1\"></span></TD></TR>";
	 } else {
         $outstring .="<TR><TD width=100% valign=top><span class=\"small\"><img src=\"$modimgurl/EventCal/EventIcons/$cicon.gif\" border=\"0\" alt=\"$icon_text\" /> $cdate <b>$icon_text</b> $eventuserlink<br />$cevent<HR class=\"hr\" size=\"1\"></span></TD></TR>";
	 }
     }
   }

   $outstring .= "</TABLE>";
   if ($Scroll_Events == 1) { $outstring .= "</marquee><br />";
   } elsif ($Scroll_Events == 2) {
   $outstring .= "</div>";
   }

#<--------------------------------------------->#
# Print Events end
#<--------------------------------------------->#

#<--------------------------------------------->#
# Print Mini EventCal begin
#<--------------------------------------------->#

if ($Show_BirthdaysList && $BirthdayList_Active) {
unless ($iamguest && ($Show_BirthdaysList == 1)) {
   $ShowBirthdaysLink = qq~<span class="small"> <img src="$modimgurl/EventCal/eventmore.gif" border="0" alt="$var_calpost{var_cal}" /> <a href="$scripturl?action=cal_birthdaylist">$var_cal{calbdaylist}</a></span>~;
}
}

   $mon_name=$var_cal{$st};

   if ($mon == 2) {
      if ($year%4 == 0) { $days=29; }
   }
   for ($i=1;$i<8;$i++) {
      $st="calday_".$i;
      $dstr[$i-1]="<TD width=\"14%\" class=\"titlebg\" align=center><span class=\"small\"><b>".$var_cal{$st}."</b></span></TD>";
   }
   $cal_out="<TR>";
   $dcnt=0;
   $e_day = $wday1;
   if ($wday1 >1) {
      for ($i=1;$i<$wday1;$i++) {
         $cal_out .= "<TD width=\"14%\" class=\"windowbg\"></TD>";
      }
   }
   if    (!$Event_TodayColor) { $Event_TodayColor = "ff0000"; }

   for ($i=1;$i<=$days;$i++) {
      $dddd = $i;
      if ($dddd < 10) { $dddd = "0$dddd"; }

      $sel = "<span class=\"small\">$i</span>";
      if ($i==$mday && $view_selday == 1) {
         $sel = "<span class=\"small\"><font color=\"#$Event_TodayColor\"><b>$i</b></font></span>";
      }

$cal_pic = '';
	if ((!exists(${event.$year.$view_mon.$dddd}{'calday'})) && (exists(${bday.$year.$view_mon.$dddd}{'calday'}))) {
	$cal_pic = "$modimgurl/EventCal/EventIcons/eventbd.gif";
	}
	if ((exists(${event.$year.$view_mon.$dddd}{'calday'})) && (!exists(${bday.$year.$view_mon.$dddd}{'calday'}))) {
	$cal_pic = "$modimgurl/EventCal/EventIcons/eventinfo.gif";
	}
	if ((exists(${event.$year.$view_mon.$dddd}{'calday'})) && (exists(${bday.$year.$view_mon.$dddd}{'calday'}))) {
	$cal_pic = "$modimgurl/EventCal/eventinfobd.gif";
	}
	if (exists(${private.$year.$view_mon.$dddd.$username.2}{'private'})) {
	$cal_pic = "$modimgurl/EventCal/EventIcons/eventprivate.gif";
	}
	if ($Show_MiniCalIcons) { $cal_pic = ''; }

	if ((exists(${bday.$year.$view_mon.$dddd}{'calday'})) || (exists(${event.$year.$view_mon.$dddd}{'calday'}))) {
	$sel = qq~<a href="$scripturl?action=get_cal;calshow=1;eventdate=$year$view_mon$dddd;showmini=1" title='$var_cal{'calshowmini'}'><u>$sel</u></a>~;
	$cal_out .="<TD width=\"14%\" class=\"windowbg2\" STYLE=\"background-image:URL('$cal_pic'); background-repeat:no-repeat;\" align=center>$sel</TD>";
	} else {
	$cal_out .="<TD width=\"14%\" class=\"windowbg2\" align=center>$sel</TD>";
	}

      $e_day++;
      $wday1++;
      if ($wday1 >7) {
         $wday1=1;
         $cal_out.="</TR><TR>";
      }
   }
   $endrow = 42;
   if ($e_day < 36) { $endrow = 35; }
   $endday = $endrow-$e_day+2;
   if ($endday < 8) {
      for ($i=1;$i<$endday;$i++) {
         $cal_out .= "<TD width=\"14%\" class=\"windowbg\"></TD>";
      }
   }
   $cal_out.="</TR>";

	if($ShowSunday) {
		$weekdays = qq~$dstr[6]$dstr[0]$dstr[1]$dstr[2]$dstr[3]$dstr[4]$dstr[5]~;
	} else {
		$weekdays = qq~$dstr[0]$dstr[1]$dstr[2]$dstr[3]$dstr[4]$dstr[5]$dstr[6]~;
	}
#<--------------------------------------------->#
# Print Mini EventCal end
#<--------------------------------------------->#

#<--------------------------------------------->#
# EventCal Output begin
#<--------------------------------------------->#

   if (!@caldata3) {
         $outstring ="<TABLE><TR><TD width=100% valign=top><span class=\"small\"><img src=\"$modimgurl/EventCal/EventIcons/eventinfo.gif\" border=\"0\" alt=\"Event\" /> $var_cal{calnoevent}<HR class=\"hr\" size=\"1\"></span></TD></TR></TABLE>";
   }
$caltablecal = "30%";
$caltablespan = "1";
$D_CalEvents = 1;
unless ($INFO{'calshow'} == 1) {
if (!$DisplayCalEvents) { $D_CalEvents = 0; }
}
if (!$D_CalEvents) { $caltablecal = "100%"; $caltablespan = "2"; }
   $cal_display .= qq~
<tr>
	<td align="left" class="catbg" colspan="2">
		<div style="float: left; width: 30%; padding-top: 5px; padding-bottom: 5px; text-align: left;"> $var_cal{'caltitle'}</div>
		<div style="float: left; width: 70%; padding-top: 4px; padding-bottom: 4px; text-align: right;">$calgotobox</div>
	</td>
</tr>
<tr>
	<td class="windowbg" width="5%" valign="middle" align="center">
		<img src="$modimgurl/EventCal/eventcal.gif" border="0" alt="" />
	</td>
	<td class="windowbg2">
	<table width=100%>
	<tr>
	<td colspan="$caltablespan" width="$caltablecal">
	<table width="100%" cellPadding=0 cellSpacing=1>
	  <tr>
	    <td class=windowbg>
<div class="seperator">
	    <table width="100%" border="0" cellpadding="3" cellspacing="1">
	      <tr>
		<td align="center" class="catbg"><span class="small">$last_link</span></TD>
		<td colspan=5 align="center" class="catbg"><span class="small"><B>$mon_name $year</B></span></TD>
		<td align="center" class="catbg"><span class="small">$next_link</span></TD>
	      </tr>
	      <tr>$weekdays</tr>
		  $cal_out
	</table>
</div>
	</td>
	</tr>
</table>
$ShowBirthdaysLink 
	</td>
~;
$D_CalEvents = 1;
unless ($INFO{'calshow'} == 1) {
if (!$DisplayCalEvents) { $D_CalEvents = 0; }
}
if ($D_CalEvents) {
   $cal_display .= qq~
	<td class="windowbg2" width=70% align=left valign=top>
		<b>$event_index</b><br />
		$outstring
	</td>
	</tr>
~;
}
   if ($Allow_Event_Imput) {
   if ($INFO{'addnew'} == 1) {
   $cal_display .= qq~
	<script type="text/javascript" src="$modimgurl/EventCal/eventcal.js" language="JavaScript"></script>
	<form action="$scripturl?action=add_cal" name=eventcal method="post">
   ~;
   }
   $cal_display .= qq~
	<tr>
	<td colspan=2>
$YaBBC_calout
	</td>
      </tr>
   </table>
   ~;
   } else {
   $cal_display .= qq~
</table>
~;
   }

## Print EventCal on BoardIndex ##
	$boardindex_template =~ s/<yabb caldisplay>/$cal_display/g;

## Print EventCal in new window ##
if ($INFO{'calshow'} == 1) { 
$yymain .= qq~
<div class="seperator">
<table cellpadding="4" cellspacing="1" border="0" width="100%">
$cal_display
</table>
</div>
~;
	$yytitle = $var_cal{yytitle};
	&template;
	exit;
}
}

#<--------------------------------------------->#
# EventCal Output end
#<--------------------------------------------->#

#<--------------------------------------------->#
# EventCal Subs begin
#<--------------------------------------------->#

## Delete Events ##

sub del_cal {

   if ("$INFO{'caldel'}" == 1) {
      if (-e "$vardir/eventcal.db") {
         fopen(FILE,"<$vardir/eventcal.db");
         @caldata=<FILE>;
         fclose(FILE);

         @hilf=grep (!/$INFO{'calid'}/, @caldata);

         fopen(FILE,">$vardir/eventcal.db");
         print FILE @hilf;
         fclose(FILE);
      }
   }

	&del_old_events;
	$yySetLocation = qq~$scripturl?action=get_cal;calshow=1~;
	&redirectexit;
}

## Add Events ##

sub add_cal {
   if (!$iamguest) {
   $heute = time + (3600 * ${$uid.$username}{'timeoffset'});
   } else {
   $heute   = time + (3600 * $timeoffset);
   }

      if (length($FORM{'calevent'}) > 0) {

	$calmessage = $FORM{'calevent'};
	$calmessage =~ s/\|//g;
	$calmessage =~ s/\cM//g;
	$calmessage =~ s~\:\`\(~\:\'\(~g;
	$calmessage =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
	$calmessage =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
	$calmessage =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
	&FromChars($calmessage);
	&ToHTML($calmessage);
	$calmessage =~ s~\t~ \&nbsp; \&nbsp; \&nbsp;~g;
	$calmessage =~ s~\n~<br />~g;
	$calmessage =~ s/([\000-\x09\x0b\x0c\x0e-\x1f\x7f])/\x0d/g;

	if ($FORM{'editid'}) {

	fopen(EVENTFILE,"$vardir/eventcal.db");
        @calinput=<EVENTFILE>;
        fclose(EVENTFILE);
	
	fopen(EVENTFILE,">$vardir/eventcal.db");
		foreach (@calinput) {
		chop $_;
		($c_date,$c_type,$c_name,$c_time,$c_event,$c_icon,$c_noname,$c_type2) = split(/\|/,$_);
			if($c_time == $FORM{'editid'}){
			print EVENTFILE "$FORM{'selyear'}$FORM{'selmon'}$FORM{'selday'}|$FORM{'caltype'}|$c_name|$c_time|$calmessage|$FORM{'calicon'}|$FORM{'calnoname'}|$FORM{'caltype2'}\n";
			} else { print EVENTFILE "$c_date|$c_type|$c_name|$c_time|$c_event|$c_icon|$c_noname|$c_type2\n"; }
		}
	fclose(EVENTFILE);


	} else {

         $outstring = "$FORM{'selyear'}$FORM{'selmon'}$FORM{'selday'}|$FORM{'caltype'}|$username|$heute|$calmessage|$FORM{'calicon'}|$FORM{'calnoname'}|$FORM{'caltype2'}";

         fopen(FILE,">>$vardir/eventcal.db");
         print FILE "$outstring\n";
         fclose(FILE);
	}
      }

	&del_old_events;
	$yySetLocation = qq~$scripturl?action=get_cal;calshow=1;calmon=$FORM{'selmon'};calyear=$FORM{'selyear'}~;
	&redirectexit;

}

## Delete old events ##

sub del_old_events {
   if (!$iamguest) {
   $heute = time + (3600 * ${$uid.$username}{'timeoffset'});
   } else {
   $heute   = time + (3600 * $timeoffset);
   }

   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$dst)=localtime($heute);
   $year += 1900;
   $mon++;
   $caltoday="$year".sprintf("%02d",$mon).sprintf("%02d",$mday);
   if ($Delete_EventsUntil !=0 && $Delete_EventsUntil < $caltoday) { $caltoday=$Delete_EventsUntil; }

        fopen(EVENTFILE,"$vardir/eventcal.db");
        @calinput=<EVENTFILE>;
        fclose(EVENTFILE);

	fopen(EVENTFILE,">$vardir/eventcal.db");
		foreach (@calinput) {
		chop $_;
		($c_date,$c_type,$c_name,$c_time,$c_event,$c_icon,$c_noname,$c_type2) = split(/\|/,$_);
			if(($c_date < $caltoday) && ($c_type2 ne 2 || $c_type2 ne 3)){
			} else { print EVENTFILE "$c_date|$c_type|$c_name|$c_time|$c_event|$c_icon|$c_noname|$c_type2\n"; }
		}
	fclose(EVENTFILE);
}

## Birthday Update ##

sub calupdatebday {

		fopen(FILE, "$memberdir/memberlist.txt");
		@birthmembers = <FILE>;
		fclose(FILE);
		fopen(FILE,">$vardir/eventcalbday.db");
		foreach $user_name (@birthmembers) {
		($user_xy, $dummy) = split(/	/, $user_name);
			chomp $user_xy;
			&LoadUser($user_xy);
			$user_xy_bd = ${$uid.$user_xy}{'bday'};
			if ($user_xy_bd) {
				($user_month, $user_day, $user_year) = split(/\//, $user_xy_bd);
				if ($user_month < 10 && length($user_month) == 1) { $user_month = "0$user_month"; }
				if ($user_day < 10 && length($user_day) == 1) { $user_day = "0$user_day"; }
				print FILE qq~$user_year|$user_month|$user_day|$user_xy\n~;

			}
		}
		fclose(FILE);

}

## Event Icon ##

sub calicontext {

my $currenticon = $_[0];

if (-e("$vardir/eventcalIcon.txt"))  {
require "$vardir/eventcalIcon.txt";
	$i=0;
	while($CalIconURL[$i]) {
		if ($CalIconURL[$i] eq "$currenticon") { $icon_out = "$CalIDescription[$i]"; }
	$i++;
	}
}

return $icon_out;

}

#<--------------------------------------------->#
# EventCal Subs end ----> !!! Finish EventCal !!!
#<--------------------------------------------->#

1;

